 /*
  * gpoke.c - CD+G player
  * Copyright (c)2003 Pawel Szymczykowski <pawel@makenai.net>
  *
  *
  * This is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
  *
  * It is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
  * along with Foobar; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  */

#include "defines.h"
#include "gpstdlib.h"
#include "gpstdio.h"
#include "gpfilereq.h"
#include "cdg.h"

unsigned char CDG_screenBuffer[76800];
GPDRAWSURFACE gpDraw;

void GpMain(void *arg)
{
	char filename[13];
	FSEL fsel = {filename, &gpDraw, 0xFF, 0x00, 0x00, 192, 192, 0x00};
	ERR_CODE err_code;
	F_HANDLE fp;
	SUBCODE subCode;
	unsigned long m_size;
	int n_tick;
	
	GpLcdSurfaceGet(&gpDraw, 0);  
	GpSurfaceSet(&gpDraw);
	
	GpFatInit();
	while(FileRequest(&fsel, "gp:\\GPMM\\CDG", 1) == 0)
	{
		err_code = GpFileOpen(filename, OPEN_R, &fp);
		if (err_code != SM_OK)	GpAppExit();

		while (GpFileRead(fp, &subCode, sizeof(SUBCODE), &m_size) == SM_OK)
		{
			if ((subCode.command & SC_MASK) == SC_CDG_COMMAND)
			{
				CDG_Handler(&subCode);
				gm_memcpy(gpDraw.ptbuffer, CDG_screenBuffer, 76800);
			}
			n_tick = GpTickCountGet();
			while ( ( GpTickCountGet() - n_tick ) < 1);
		}

		GpFileClose(fp);
	}
	GpAppExit();
}
